/*
 * Ambient Occlusion Surface Shader
 *
 * (c) 2007 Jeremy Huddleston <jeremyhu@cs.berkeley.edu>
 *
 * Released under the terms of the LGPL-2:
 * http://www.fsf.org/licensing/licenses/lgpl.txt
 */

surface amboccl(float samples = 16;
                float method=0;
                float maxdist=1e30;
                float coneangle = PI/2) {
    normal Nf = faceforward(normalize(N), I);;
    float occ;

    if(method == 0) {
      occ = occlusion(P, Nf, samples,
                      "maxdist", maxdist, "coneangle", coneangle,
                      "distribution", "cosine");
    } else {
      float hits = 0;
      gather("illuminance", P, Nf, coneangle, samples, "distribution", "cosine", "maxdist", maxdist) {
        hits += 1;
       }
       occ = hits / samples;
    }

    Ci = 1 - occ;
    Oi = 1;
}
