/*
** Copyright (c) 2001 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1200 Park Ave
** Emeryville, CA 94608
**
** ----------------------------------------------------------------------------
*/

/* code generated by slim 6.5.3, RAT 6.5.3 (May 15 2006 03:07:00) */
/* for jeremy@yuffie.outersquare.org at: Fri Apr 20 22:07:43 PDT 2007 */
/* shader modification timestamp: 1177132063 */

/* includes ---------------------------------*/
#include "blinn.h"
#include "pxslAOV.h"
#include "pxslRayUtil.h"
/* defines ----------------------------------*/
#define SLIM_TYPEID_surface 0
#define SLIM_TYPEID_displacement 1
#define SLIM_TYPEID_volume 2
#define SLIM_TYPEID_light 3
#define SLIM_VERSION 650
#define SLIM_SHADERTYPE surface
#define SLIM_SHADERTYPEID SLIM_TYPEID_surface
#define SLIM_INSTANCETYPE shadingmodel_aov
#define SLIM_INSTANCENAME Blinn

/* shader body ------------------------------*/
SLIM_SHADERTYPE
SLIM_INSTANCENAME (
  output varying color _ambient=0;
  output varying color _backscattering=0;
  output varying color _diffuse=0;
  output varying color _incandescence=0;
  output varying color _indirect=0;
  output varying color _reflection=0;
  output varying color _refraction=0;
  output varying color _rim=0;
  output varying color _shadow=0;
  output varying color _specular=0;
  output varying color _subsurfacescattering=0;
  output varying color _surfacecolor=0;
  output varying color _thintranslucence=0;
)
{

/* static functions ----------------------*/

		void pxslDiffuseSC(
		    float Kd;
		    color coloration;
		    uniform float lightType;
		    normal Ns;
		    output color col;
		    DECLARE_AOV_OUTPUT_PARAMS
		)
		{
		    INIT_AOV_OUTPUT_PARAMS

		    col = 0;
#if SLIM_SHADERTYPEID != SLIM_TYPEID_light
		    extern point P;
		    color inshadow;

		    if (lightType <= 0)
		    {
			illuminance("-environment", P, Ns, 1.57,
			    "lightcache", "reuse")
			{
			    float nondiff = 0;
			    lightsource("__nondiffuse", nondiff);
			    if (nondiff < 1)
			    {
				if( 0 != lightsource("__inShadowC", inshadow) )
				    c_shadow += inshadow;
				col += Cl * (1-nondiff) * 
				    normalize(L).Ns;
			    }
			}
		    }
		    if (lightType >= 0)
		    {
			illuminance ("environment", P, Ns, 1.57,
			    "send:light:__coneangle", 1.57,
			    "send:light:__coneaxis", Ns,
			    "lightcache", "refresh")
			{
			    float nondiff = 0;
			    lightsource("__nondiffuse", nondiff);
			    if (nondiff < 1)
			    {
				if( 0 != lightsource("__inShadowC", inshadow) )
				    c_shadow += inshadow;
				col += (1-nondiff) * Cl;
			    }
			}
		    }
		    col *= coloration * Kd;
#endif
		    c_surfacecolor = coloration;
		    c_diffuse = col;
		}
	    

	void
	pxslSurfaceNormal(uniform float normalize;
			output normal n;)
	{
	    extern normal N;
	    if(normalize == 0)
		n = N;
	    else
		n = normalize(N);
	}
    

	void
	pxslIncidentDirection(uniform float normalize;
			    uniform float flip;
			    output vector V;)
	{
	    extern vector I;
	    if(normalize == 0)
		V = I;
	    else
		V = normalize(I);
	    if(flip != 0)
		V = -V;
	}
    

	void
	pxslShadingNormal(varying vector incident;
			  varying normal n;
			  output normal ns;)
	{
	    uniform float depth;
	    rayinfo("depth", depth);
	    if(depth > 0)
		ns = faceforward(n, incident, n);
	    else
	    {
		uniform float sides = 2;
		attribute("Sides", sides);
		if(sides == 2)
		    ns = faceforward(n, incident, n);
		else
		    ns = n;
	    }
	}
    

/* dynamic functions ------------------------*/
    
/* ----------------------------------------------*/
    void pxslBlinn_func7 ( /* Blinn */
      uniform color SurfaceColor;
      uniform color SurfaceOpacity;
      uniform float Ka;
      uniform color ambientColor;
      uniform color Incandescence;
      uniform float translucenceCoeff;
      color diff_col;
      color diff_shadow;
      color diff_surfacecolor;
      color diff_incandescence;
      color diff_ambient;
      color diff_indirect;
      color diff_diffuse;
      color diff_thintranslucence;
      color diff_subsurfacescattering;
      color diff_backscattering;
      color diff_specular;
      color diff_rim;
      color diff_reflection;
      color diff_refraction;
      uniform color SpecularColor;
      uniform float eccentricity;
      uniform float specularRollOff;
      uniform float reflectivity;
      normal Normal;
      output color CI;
      output color OI;
      output color c_shadow;
      output color c_surfacecolor;
      output color c_incandescence;
      output color c_ambient;
      output color c_indirect;
      output color c_diffuse;
      output color c_thintranslucence;
      output color c_subsurfacescattering;
      output color c_backscattering;
      output color c_specular;
      output color c_rim;
      output color c_reflection;
      output color c_refraction;
      )
    {
      color Ia, Id, Itr, Is, Ir, Isr;
      Ia = Ka * ambientColor * ambient();
      Itr = blinnTranslucence(Normal, translucenceCoeff);
      Id = diff_col;
      Is = blinnSpecular(Normal, eccentricity, specularRollOff, Ir);
      Ir = reflectivity * Ir;
      Isr = SpecularColor * (Is + Ir);
      OI = SurfaceOpacity;
      CI = SurfaceColor * (Ia + Id) + Itr + Incandescence + Isr;
      CI *= OI;
      
      /* handle incoming AOVs */
      c_surfacecolor = SurfaceOpacity * diff_surfacecolor;
      c_incandescence = SurfaceOpacity * diff_incandescence;
      c_ambient = SurfaceOpacity * diff_ambient;
      c_indirect = SurfaceOpacity * diff_indirect;
      c_diffuse = SurfaceOpacity * diff_diffuse;
      c_thintranslucence = SurfaceOpacity * diff_thintranslucence;
      c_subsurfacescattering = SurfaceOpacity * diff_subsurfacescattering;
      c_backscattering = SurfaceOpacity * diff_backscattering;
      c_specular = SurfaceOpacity * diff_specular;
      c_rim = SurfaceOpacity * diff_rim;
      c_reflection = SurfaceOpacity * diff_reflection;
      c_refraction = SurfaceOpacity * diff_refraction;
      
      /* accumulate AOVs for local illumination */
      c_ambient += OI * SurfaceColor * Ia;
      c_incandescence += OI * Incandescence;
      c_specular += OI * Isr;
      c_thintranslucence += OI * Itr;
    }

/* local variables --------------------------*/
  normal tmp1;
  normal tmp2;
  vector tmp0;
  color tmp31;
  color tmp27;
  color tmp8;
  color tmp19;
  color tmp28;
  color tmp26;
  color tmp3;
  color tmp29;
  color tmp22;
  color tmp20;
  color tmp23;
  color tmp21;
  color tmp14;
  color tmp7;
  color tmp10;
  color tmp24;
  color tmp18;
  color tmp15;
  color tmp6;
  color tmp16;
  color tmp12;
  color tmp4;
  color tmp9;
  color tmp25;
  color tmp17;
  color tmp11;
  color tmp13;
  color tmp30;
  color tmp5;

/* main body --------------------------------*/
  /* generate (all) ----------- */
  pxslIncidentDirection ( /* IncidentDirection */
    1, /* Normalize */
    0, /* Flip */
    tmp0  /* result */ 
    );
  pxslSurfaceNormal ( /* SurfaceNormal */
    1, /* Normalize */
    tmp1  /* result */ 
    );
  pxslShadingNormal ( /* ShadingNormal */
    tmp0, /* Forward */ 
    tmp1, /* Normal */ 
    tmp2  /* result */ 
    );
  pxslDiffuseSC ( /* Diffuse */
    0.000, /* Intensity */
    color(1,1,1), /* Color */
    0, /* Use */
    tmp2, /* Normal */ 
    tmp3, /* col */ 
    tmp4, /* c_shadow */ 
    tmp5, /* c_surfacecolor */ 
    tmp6, /* c_incandescence */ 
    tmp7, /* c_ambient */ 
    tmp8, /* c_indirect */ 
    tmp9, /* c_diffuse */ 
    tmp10, /* c_thintranslucence */ 
    tmp11, /* c_subsurfacescattering */ 
    tmp12, /* c_backscattering */ 
    tmp13, /* c_specular */ 
    tmp14, /* c_rim */ 
    tmp15, /* c_reflection */ 
    tmp16  /* c_refraction */ 
    );
  pxslBlinn_func7 ( /* Blinn */
    color(1.0,1.0,1), /* Surface Color */
    color(1,1,1), /* Opacity */
    0.00, /* Ka */
    color(1,1,1), /* Ambient Color */
    color(0,0,0), /* Incandescence */
    0, /* Translucence Coefficient */
    tmp3, /* diff_col */ 
    tmp4, /* diff_shadow */ 
    tmp5, /* diff_surfacecolor */ 
    tmp6, /* diff_incandescence */ 
    tmp7, /* diff_ambient */ 
    tmp8, /* diff_indirect */ 
    tmp9, /* diff_diffuse */ 
    tmp10, /* diff_thintranslucence */ 
    tmp11, /* diff_subsurfacescattering */ 
    tmp12, /* diff_backscattering */ 
    tmp13, /* diff_specular */ 
    tmp14, /* diff_rim */ 
    tmp15, /* diff_reflection */ 
    tmp16, /* diff_refraction */ 
    color(1,1,1), /* Specular Color */
    0.20, /* Eccentricity */
    1.00, /* Specular Rolloff */
    0.80, /* Reflectivity */
    tmp2, /* Normal */ 
    tmp17, /* CI */ 
    tmp18, /* OI */ 
    tmp19, /* c_shadow */ 
    tmp20, /* c_surfacecolor */ 
    tmp21, /* c_incandescence */ 
    tmp22, /* c_ambient */ 
    tmp23, /* c_indirect */ 
    tmp24, /* c_diffuse */ 
    tmp25, /* c_thintranslucence */ 
    tmp26, /* c_subsurfacescattering */ 
    tmp27, /* c_backscattering */ 
    tmp28, /* c_specular */ 
    tmp29, /* c_rim */ 
    tmp30, /* c_reflection */ 
    tmp31  /* c_refraction */ 
    );
  Ci = tmp17;
  Oi = tmp18;
  _shadow = tmp19;
  _surfacecolor = tmp20;
  _incandescence = tmp21;
  _ambient = tmp22;
  _indirect = tmp23;
  _diffuse = tmp24;
  _thintranslucence = tmp25;
  _subsurfacescattering = tmp26;
  _backscattering = tmp27;
  _specular = tmp28;
  _rim = tmp29;
  _reflection = tmp30;
  _refraction = tmp31;
}

