/*
** Copyright (c) 2001 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1200 Park Ave
** Emeryville, CA 94608
**
** ----------------------------------------------------------------------------
*/

/* code generated by slim 6.5.3, RAT 6.5.3 (May 15 2006 03:07:00) */
/* for jeremy@yuffie.outersquare.org at: Fri Apr 20 18:18:16 PDT 2007 */
/* shader modification timestamp: 1177116896 */

/* includes ---------------------------------*/
#include "pxslUtil.h"
/* defines ----------------------------------*/
#define SLIM_TYPEID_surface 0
#define SLIM_TYPEID_displacement 1
#define SLIM_TYPEID_volume 2
#define SLIM_TYPEID_light 3
#define SLIM_VERSION 650
#define SLIM_SHADERTYPE light
#define SLIM_SHADERTYPEID SLIM_TYPEID_light
#define SLIM_INSTANCETYPE light
#define SLIM_INSTANCENAME KeyLightShadowMapGen

/* shader body ------------------------------*/
SLIM_SHADERTYPE
SLIM_INSTANCENAME (
  string ShadowMapPointlight_1_Shadow_px="";
  string ShadowMapPointlight_1_Shadow_nx="";
  string ShadowMapPointlight_1_Shadow_py="";
  string ShadowMapPointlight_1_Shadow_ny="";
  string ShadowMapPointlight_1_Shadow_pz="";
  string ShadowMapPointlight_1_Shadow_nz="";
  output varying float __nondiffuse=1;
  output varying float __nonspecular=1;
  output varying color __inShadowC=color(0,0,0);
  output varying float _contribRim=1;
  output varying float _contribThinTranslucence=1;
  output varying float _contribBackScattering=1;
  output varying float _contribSubsurfaceScattering=1;
)
{

/* static functions ----------------------*/

	    void
	    pxslCShadowMapPointlight (
		float samples;
		float blur;
		float bias;
		string pxmap;
		string nxmap;
		string pymap;
		string nymap;
		string pzmap;
		string nzmap;
		output color result; )
	    {
		color
		getshadow(string filename;
				point Q;
				float samples;
				float blur;
				float bias;)
		{
	    	    color result = 0;
	    	    if(filename != "")
		    {
			if(bias != 0)
			    result = color shadow(filename, Q,
						"samples", samples,
						"swidth", blur,
						"twidth", blur,
						"bias", bias);
			else
			    result = color shadow(filename, Q,
						"samples", samples,
						"swidth", blur,
						"twidth", blur);
		    }
		    return result;
		}
		result = color(0);
#if SLIM_SHADERTYPEID == SLIM_TYPEID_light
		extern vector L;
		extern point Ps;
		vector Lrel = vtransform("shader", L);
		float Lx = xcomp(Lrel);
		float AbsLx = abs(Lx);
		float Ly = ycomp(Lrel);
		float AbsLy = abs(Ly);
		float Lz = zcomp(Lrel);
		float AbsLz = abs(Lz);
		if (pxmap != "")
		{
		    if(AbsLx > AbsLy && AbsLx > AbsLz && Lx > 0)
		    {

			 result = getshadow(pxmap, Ps,  samples, blur, bias);
		    }
		}
		if (nxmap != "")
		{
		    if(AbsLx > AbsLy && AbsLx > AbsLz && Lx <= 0)
		    {
			 result = getshadow(nxmap, Ps,  samples, blur, bias);
		    }
		}
		if (pymap != "")
		{
		    if(AbsLy > AbsLx && AbsLy > AbsLz && Ly > 0)
		    {
			 result = getshadow(pymap, Ps,  samples, blur, bias);
		    }
		}
		if (nymap != "")
		{
		    if(AbsLy > AbsLx && AbsLy > AbsLz && Ly <= 0)
		    {
			 result = getshadow(nymap, Ps,  samples, blur, bias);
		    }
		}
		if (pzmap != "")
		{
		    if(AbsLz > AbsLy && AbsLz > AbsLx && Lz > 0.0)
		    {
			 result = getshadow(pzmap, Ps,  samples, blur, bias);
		    }
		}
		if (nzmap != "")
		{
		    if(AbsLz > AbsLy && AbsLz > AbsLx && Lz <= 0.0)
		    {
			 result = getshadow(nzmap, Ps,  samples, blur, bias);
		    }
		}
#endif
	    }
    	

/* dynamic functions ------------------------*/

/* local variables --------------------------*/
  color tmp0;

/* main body --------------------------------*/
  float atten, len;
  float Lx, Ly, Lz, AbsLx, AbsLy, AbsLz;
  vector Lrel;
  extern point Ps;
  __inShadowC = color(0);
  illuminate(point "shader" (0,0,0)) {
    len = length(L);
    atten = 1 / pow(length(L), 0);
    /* generate (all) ----------- */
    pxslCShadowMapPointlight ( /* ShadowMapPointlight_1 */
      16, /* Samples */
      0, /* Blur */
      0, /* Bias */
      ShadowMapPointlight_1_Shadow_px, /* Shadow_px */
      ShadowMapPointlight_1_Shadow_nx, /* Shadow_nx */
      ShadowMapPointlight_1_Shadow_py, /* Shadow_py */
      ShadowMapPointlight_1_Shadow_ny, /* Shadow_ny */
      ShadowMapPointlight_1_Shadow_pz, /* Shadow_pz */
      ShadowMapPointlight_1_Shadow_nz, /* Shadow_nz */
      tmp0  /* result */ 
      );
    __inShadowC = tmp0;
    __nondiffuse = 1 - 1;
    __nonspecular = 1 - 1;
    _contribRim = 1;
    _contribThinTranslucence = 1;
    _contribBackScattering = 1;
    _contribSubsurfaceScattering = 1;
    Cl = atten * 1 * color(1,1,1);
    Cl = pxslCmix(Cl, color(0,0,0), __inShadowC);
  }
}

