/*
** Copyright (c) 2006 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1200 Park Ave
** Emeryville, CA 94608
**
** ----------------------------------------------------------------------------
*/

/* code generated by slim 7.1 (Oct  4 2007 01:14:49) */
/* for jeremy@tifa.local at: Tue Apr 14 01:21:49 PDT 2009 */
/* shader modification timestamp: 1177312146 */


/* Slim interface meta data
 *
<meta id="slim"><![CDATA[
#
# generated by slim for jeremy at Tue Apr 14 01:21:49 PDT 2009
#
slim 2 appearance slim {
  instance light Spot rmanshader/Spot {
    previewinfo {
      frame 1
      primitive Sphere
      shadingrate 1
      size 1
    }
    lighttype spot
    creator {
      timestamp 1177312146
      session mtor
      label slim_shadows
      containerid A0W22OaA9tC00000
      appearanceid A0W22OaA9tC000W0
      filename /Users/jeremy/Documents/maya/projects/comp_lec/myShaders/slim_shadows.splt
      translator slim
      workspace /Users/jeremy/Documents/maya/projects/comp_lec/RATworkspace.ws
      container {slim external palette}
    }
    collection void Spot {
      state open
      torattribute int EmitsPhotons {
        label {Emits Photons}
        description {This attribute determines whether a light should take part in photon map generation. Light sources that don't emit real illumination (like indirect) should NOT take part in photon map generation since their purpose is to collect illuminance information in other contexts. }
        subtype switch
        default 0
        value 0
      }
      riattribute string CoordSysTransform {
        label {Shader Space}
        description {The coordinate system in which a shader is defined. Most shaders perform important calculations relative to this space and so transforming it affects their appearance. If empty, the shader space is the object space associated with the attached primitive. Place the name of a coordinate system object here to set the shader space for the shader. If you're using file referencing, use the "coordsys" function to translate the name of the coordinate system (eg: [coordsys mtorCoordSysShape10]. }
        default {}
        value {}
      }
      parameter float ConeAngle {
        label ConeAngle
        description {The cone angle in of the spotlight, measured in degrees. You can cause this cone angle to match that of your modeler with an expression like: deg($CONEANGLE)}
        expression {deg($CONEANGLE)}
        range {1 180 1}
        subtype slider
        provider expression
        default 30
        value 30
      }
      parameter float PenumbraAngle {
        label PenumbraAngle
        description {The softly lit area at the edge of the spotlight, measured in degrees. You can cause this angle to match that of your modeler with an expression like: deg($PENUMBRAANGLE)}
        expression {deg($PENUMBRAANGLE)}
        range {0 180 1}
        subtype slider
        provider expression
        default 5
        value 5
      }
    }
    collection void ShadowMap {
      state open
      collection __workgenerator {ShadowMap_make shadow map} {
        label {make shadow map}
        description {Attach this to any camera, coordinate system or light to cause the calculation of a shadow map.}
        state open
        torattribute string type {
          label type
          display hidden
          default shadow
          value shadow
        }
        torattribute string context {
          label Context
          description {Specifies the value of the CONTEXT global during the rendering of this element. The value of the CONTEXT global can be consulted by Adaptor appearances to choose context-specific appearance attachment.}
          default {}
          value {}
        }
        torattribute string customSettings {
          label {Custom Settings}
          description {Specifies the name of site-configuration custom settings, usually specified in TOR.ini. Custom Settings allow you to define TCL state, RiOptions and default RiAttributes on a per-pass basis. }
          subtype prefselector.RMCCustomPassSettings.1from2
          default {}
          value {}
        }
        torattribute string frequency {
          label Frequency
          description {Controls how often you want to compute your shadow map. Usually you should choose "Every Frame" but if you know that the map's contents are invariant over a sequence, choose "Once Per Job"}
          range {
		    Never never
		    {Every Frame} frame
		    {Once Per Job} job
		}
          subtype selector
          default frame
          value job
        }
        torattribute string locator {
          label {Camera Name}
          description {The name of the camera from which to compute the shadow map. Normally this should be empty, but if you wish to compute a map from an non-attached object, enter its name here. }
          default {}
          value {}
        }
        torattribute string crew {
          label {Objects in Map}
          default {}
          value {}
        }
        torattribute string lazy {
          label Laziness
          range {
		    Off off
		    On  on
		    {Use Global} global
		}
          subtype selector
          default global
          value on
        }
        torattribute string cacheUniquifier {
          label cacheUniquifier
          display hidden
          default {$OBJNAME}
          value slimobj
          slimvalue {$OBJNAME}
        }
        torattribute float near {
          label Near
          description {The near clipping plane for the map calculation. When set to 0 the global near clipping plane is used.}
          range {0 1000 .01}
          default 0
          value 0.00
        }
        torattribute float far {
          label Far
          description {The far clipping plane for the map calculation. When set to 0 the global far clipping plane is used.}
          range {0 1000 .01}
          default 0
          value 100.00
        }
        torattribute float resolution {
          label {Map Resolution}
          range {
			{Render Globals}  0
			128 128
			256 256
			512 512
			1024 1024
			2048 2048
			4096 4096
			8192 8192
			16384 16384
		    }
          subtype selector
          default 512
          value 1024
        }
        torattribute string depthfilter {
          label {Depth Filter}
          description {The algorithm for calculating shadow maps.}
          range {
	       min min
	       max max
	       average average
	       midpoint midpoint
	       }
          subtype selector
          default min
          value midpoint
        }
        torattribute string shadowtype {
          label {Shadow Type}
          description {The representation of your shadow maps. Deep shadows are larger and slower than Standard and Min-Max. But they do capture transparent shadowing effects for partially transparent and tiny objects. To create a subsample resolution depth map for PRMan's depth-mask feature, select "Depth Mask" and set resolution to "Render Globals". Resolution of standard shadow maps must be a power of 2.}
          range {
		    Standard stdshadow
		    Min-Max minmaxshadow 
		    {Deep Shadow} deepopacity
		    {Depth Mask} depthmask
		}
          subtype selector
          default stdshadow
          value minmaxshadow
        }
        torattribute float pixelsamples {
          label {Pixel Samples}
          description {The number of pixel samples in x and y for your shadow maps. When using deep shadows or depth masks, you will get better results with pixel samples greater than one. Otherwise one pixel sample is usually sufficient. Set this value to 0 to use Render Globals pixel samples.}
          range {0 9 1}
          subtype slider
          default 1
          value 2
        }
        torattribute int motionblur {
          label {Motion Blur}
          description {Enables motion blur during shadow map calculation. Only enable this when computing deep shadow maps or depth masks and only if you want blurred shadows. }
          subtype switch
          default 0
          value 0
        }
        torattribute string dshdvolinterp {
          label {Volume Interpretation}
          description {Only used for deep shadows, this parameter controls the deep shadow representation. If your objects have volume over which the opacity varies continuously you should specify Continuous. If your objects are thin sheets of material you should choose Discrete. }
          range { Continuous continuous Discrete discrete }
          subtype selector
          default discrete
          value discrete
        }
      }
      parameter string ShadowMap_File {
        label File
        description {The name of your shadow map. You can refer to shadows with a tcl expression like: [shdmap $OBJNAME]}
        subtype shadow
        default {[shdmap $OBJNAME]}
        value rmantex/shd/cornell_shadows_ShadowGen.spotLightShape1.shd.tex
      }
    }
    collection void CausticPhotonMap {
      state open
      collection __workgenerator {CausticPhotonMap_make photon map} {
        label {make photon map}
        description {Attach this to any camera, coordinate system or light to cause the calculation of a photon map.}
        state open
        torattribute string type {
          label type
          display hidden
          default photon
          value photon
        }
        torattribute string context {
          label Context
          description {Specifies the value of the CONTEXT global during the rendering of this element. The value of the CONTEXT global can be consulted by Adaptor appearances to choose context-specific appearance attachment.}
          default {}
          value {}
        }
        torattribute string customSettings {
          label {Custom Settings}
          description {Specifies the name of site-configuration custom settings, usually specified in TOR.ini. Custom Settings allow you to define TCL state, RiOptions and default RiAttributes on a per-pass basis. }
          subtype prefselector.RMCCustomPassSettings.1from2
          default {}
          value {}
        }
        torattribute string frequency {
          label Frequency
          description {Controls how often you want to compute your photon map. Usually you should choose "Every Frame" but if you know that the map's contents are invariant over a sequence, choose "Once Per Job"}
          range {
		    Never never
		    {Every Frame} frame
		    {Once Per Job} job
		}
          subtype selector
          default frame
          value frame
        }
        torattribute string locator {
          label {Camera Name}
          description {The name of the camera from which to compute the photon map. Normally this should be empty, but if you wish to compute a map from an non-attached object, enter its name here. }
          default {}
          value {}
        }
        torattribute string crew {
          label {Objects in Map}
          default {}
          value {}
        }
        torattribute string lazy {
          label Laziness
          range {
		    Off off
		    On  on
		    {Use Global} global
		}
          subtype selector
          default global
          value global
        }
        torattribute string cacheUniquifier {
          label cacheUniquifier
          display hidden
          default {$OBJNAME}
          value slimobj
          slimvalue {$OBJNAME}
        }
        torattribute string PhotonPass {
          label {Photon Pass}
          description {Photon map generation is a separate rendering pass akin to shadow map generation. Photons are tagged as global and/or caustic. Caustic photons are deposited into the optional caustic photon map and are specially tuned for use in calculating caustic effects. Global photons are deposited into the optional global photon map and are used to calculate soft indirect illumination. You can generate either or both types of photon maps in a single rendering pass, but if you need very high quality caustics, you'll probably want to increase the photon emission and compute them in a separate photon pass. }
          range {
			{Global Photons Only} GlobalPhoton
			{Caustic Photons Only} CausticPhoton
			{Global And Caustic Photons} GlobalAndCausticPhoton
		    }
          subtype selector
          default CausticPhoton
          value CausticPhoton
        }
        torattribute int PhotonEmission {
          label {Photons to Emit}
          description {The number of photons to emit during map creation. }
          range {100 1000000 1000}
          subtype vslider
          default 10000
          value 10000
        }
        torattribute int PhotonEstimator {
          label Estimator
          description {Controls the number of photons to consider when precomputing radiance estimates during the construction of a global photon map. This value is ignored during caustic map generation. }
          range {-1 1000 1}
          subtype slider
          default 50
          value 50
        }
        torattribute int MaxSpecularDepth {
          label {Max Specular Depth}
          description {The maximum number of specular bounces a photon can traverse. }
          range {0 10 1}
          subtype slider
          default 5
          value 5
        }
        torattribute int MaxDiffuseDepth {
          label {Max Diffuse Depth}
          description {The maximum number of diffuse bounces a photon can traverse. }
          range {0 10 1}
          subtype slider
          default 5
          value 5
        }
      }
      parameter string pixar_PhotonMapCaustic_PhotonMap {
        label PhotonMap
        subtype photoncaustic
        default {[photonmap $OBJNAME caustic]}
        value {}
        slimvalue {[photonmap $OBJNAME caustic]}
      }
    }
  }
}
]]></meta>
<meta id="slimtemplates">
  <template vendor="pixar" version="0">
    <fullname>pixar,CShadowMap#0</fullname>
    <name>CShadowMap</name>
    <usagecount>1</usagecount>
  </template>
  <template vendor="pixar" version="3">
    <fullname>pixar,Spot#3</fullname>
    <name>Spot</name>
    <usagecount>1</usagecount>
  </template>

</meta>
/* includes ---------------------------------*/
#include "pxslRayUtil.h"
#include "pxslUtil.h"
/* defines ----------------------------------*/
#define SLIM_TYPEID_surface 0
#define SLIM_TYPEID_displacement 1
#define SLIM_TYPEID_volume 2
#define SLIM_TYPEID_light 3
#define SLIM_VERSION 710
#define SLIM_SHADERTYPE light
#define SLIM_SHADERTYPEID SLIM_TYPEID_light
#define SLIM_INSTANCETYPE light
#define SLIM_INSTANCENAME Spot

/* shader body ------------------------------*/
SLIM_SHADERTYPE
SLIM_INSTANCENAME (
                 string  ShadowMap_File = "rmantex/shd/cornell_shadows_ShadowGen.spotLightShape1.shd.tex";
                 string  pixar_PhotonMapCaustic_PhotonMap = "";
                 float   ConeAngle = 30;
                 float   PenumbraAngle = 5;
  output varying float   __nondiffuse = 1;
  output varying float   __nonspecular = 1;
  output varying color   _shadow = color (0,0,0);
  output varying color   _cl_noshadow = color (0,0,0);
  output varying float   _contribRim = 1;
  output varying float   _contribThinTranslucence = 1;
  output varying float   _contribBackScattering = 1;
  output varying float   _contribSubsurfaceScattering = 1;
  uniform string _SlimAppLabel = "Spot";
  uniform string _SlimAppID = "A0W22OaA9tC000W0";
)
{

  
/* static functions ----------------------*/
  
  	void
  	pxslShadingNormal(varying vector incident;
  			  varying normal n;
  			  output normal ns;)
  	{
  	    uniform float depth;
  	    rayinfo("depth", depth);
  	    if(depth > 0)
  		ns = faceforward(n, incident, n);
  	    else
  	    {
  		uniform float sides = 2;
  		attribute("Sides", sides);
  		if(sides == 2)
  		    ns = faceforward(n, incident, n);
  		else
  		    ns = n;
  	    }
  	}
      
  
  	    void
  	    pxslCShadowMap(
  	    	string filename;
  		float samples;
  		float blur;
  		float bias;
  		point Q;
  		vector dQu;
  		vector dQv;
  		output color result; )
  	    {
  	    	if(filename == "")
  		{
  	    	    result = 0;
  		}
  		else
  	    	if(bias != 0)
  		{
  		    result = color shadow(filename, Q,
  		    	    	"samples", samples,
  				"blur", blur,
  				"bias", bias);
  		}
  		else
  		{
  		    result = color shadow(filename, Q,
  		    	    	"samples", samples,
  				"blur", blur);
  		}
  	    }
      	
  
  	void
  	pxslIncidentDirection(uniform float normalize;
  			    uniform float flip;
  			    output vector V;)
  	{
  	    extern vector I;
  	    if(normalize == 0)
  		V = I;
  	    else
  		V = normalize(I);
  	    if(flip != 0)
  		V = -V;
  	}
      
  
  	    void
  	    pxslPhotonMapCaustic(
  		uniform string mapname;
  		uniform string lookuptype;
  		point Q;
  		vector dQu;
  		vector dQv;
  		normal Nn;
  		output color result;)
  	    {
  		if (mapname != "")
  		{
  		    result = photonmap(mapname, Q, Nn, 
  				    "lookuptype", lookuptype);
  		}
  		else
  		{
  		    result = color(0);
  		}
  	    }
  	
  
  	void
  	pxslSurfaceNormal(uniform float normalize;
  			output normal n;)
  	{
  	    extern normal N;
  	    if(normalize == 0)
  		n = N;
  	    else
  		n = normalize(N);
  	}
      
  
  		void pxslCurrentPoint (
  		    uniform float frequency;
  		    output varying point Q; 
  		    output varying vector duQ;
  		    output varying vector dvQ;
  		) 
  		{
  		    extern point P, Ps;
  		    extern float du, dv;
  #if SLIM_SHADERTYPEID == SLIM_TYPEID_light
  		    Q = frequency * Ps;
  #else
  		    Q = frequency * P;
  #endif
  		    duQ = Du(Q)*du;
  		    dvQ = Dv(Q)*dv;
  		}
  	    


/* dynamic functions ------------------------*/

/* local variables --------------------------*/
  normal tmp4;
  normal tmp6;
  color tmp5;
  vector tmp3;
  point tmp0;
  vector tmp1;
  vector tmp2;
  color tmp7;

/* main body --------------------------------*/
  point from = point "shader"(0,0,0);
  vector axis = normalize(vector "shader"(0,0,1));
  uniform float angle = radians(ConeAngle);
  uniform float penumbra = radians(PenumbraAngle);
  uniform float cosoutside = cos(angle);
  uniform float cosinside = cos(angle-penumbra);
  _shadow = color(0);
  /* generate (all) ----------- */
  pxslCurrentPoint ( /* CurrentPoint */
    1, /* Frequency */
    tmp0, /* Q */ 
    tmp1, /* dQu */ 
    tmp2  /* dQv */ 
    );
  pxslIncidentDirection ( /* IncidentDirection */
    1, /* Normalize */
    0, /* Flip */
    tmp3  /* result */ 
    );
  pxslSurfaceNormal ( /* SurfaceNormal */
    1, /* Normalize */
    tmp4  /* result */ 
    );
  pxslCShadowMap ( /* ShadowMap */
    ShadowMap_File, /* File */
    16, /* Samples */
    0, /* Blur */
    0, /* Bias */
    tmp0, /* Q */ 
    tmp1, /* dQu */ 
    tmp2, /* dQv */ 
    tmp5  /* result */ 
    );
  pxslShadingNormal ( /* ShadingNormal */
    tmp3, /* Forward */ 
    tmp4, /* Normal */ 
    tmp6  /* result */ 
    );
  pxslPhotonMapCaustic ( /* CausticPhotonMap */
    pixar_PhotonMapCaustic_PhotonMap, /* PhotonMap */
    "irradiance", /* Lookup */
    tmp0, /* Q */ 
    tmp1, /* dQu */ 
    tmp2, /* dQv */ 
    tmp6, /* normal */ 
    tmp7  /* result */ 
    );
  illuminate(from, axis, angle) {
    varying float atten, cosangle;
    cosangle = L.axis / length(L);
    atten = smoothstep( cosoutside, cosinside, cosangle );
    atten *= 1 / pow(length(L), 0);
    _shadow = tmp5;
    __nondiffuse = 1 - 1;
    __nonspecular = 1 - 1;
    _contribRim = 1;
    _contribThinTranslucence = 1;
    _contribBackScattering = 1;
    _contribSubsurfaceScattering = 1;
    Cl = atten * 1 * color (0.000,0.000,0.000);
    _cl_noshadow = Cl;
    Cl = pxslCmix(Cl, color (1.000,1.000,1.000), _shadow);
  }
}

